import warnings

from isddc_baseclass import ObjectMode


class IsddcException(metaclass=ObjectMode):
    history = {}

    def __getattribute__(self, name: str) -> type:
        if name[:2] == name[-2:] == '__':
            return

        if name == 'history':
            return super().__getattribute__(name)

        if name in self.history:
            return self.history[name]

        if name == 'IsddcError':
            return IsddcError

        if name[-5:] != 'Error':
            msg = f'Strange exception class: "{name}", ' \
                  f'exception class name should end with "Error".'
            warnings.warn(msg)

        eclass = type(name, (IsddcError,), {'__module__': 'E'})
        self.history[name] = eclass

        return eclass

    def __getitem__(self, name: str) -> type:
        return getattr(self, name)


class IsddcError(Exception):
    __module__ = 'E'

    # def __init__(self, *msg, split: str = ' '):
    #     self.msg = split.join((str(x) for x in msg))

    # def __str__(self):
    #     return self.msg
